<!DOCTYPE html>
<html class="writer-html5" lang="en">
<head>
  <meta charset="utf-8" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>nl2declare.evaluation.evaluator &mdash; NL2Declare  documentation</title>
      <link rel="stylesheet" type="text/css" href="../../../_static/pygments.css" />
      <link rel="stylesheet" type="text/css" href="../../../_static/css/theme.css" />

  
  <!--[if lt IE 9]>
    <script src="../../../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script data-url_root="../../../" id="documentation_options" src="../../../_static/documentation_options.js"></script>
        <script src="../../../_static/jquery.js"></script>
        <script src="../../../_static/underscore.js"></script>
        <script src="../../../_static/_sphinx_javascript_frameworks_compat.js"></script>
        <script src="../../../_static/doctools.js"></script>
    <script src="../../../_static/js/theme.js"></script>
    <link rel="index" title="Index" href="../../../genindex.html" />
    <link rel="search" title="Search" href="../../../search.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >

          
          
          <a href="../../../index.html" class="icon icon-home">
            NL2Declare
          </a>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" aria-label="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <p class="caption" role="heading"><span class="caption-text">Contents:</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../modules.html">nl2declare</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../../index.html">NL2Declare</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="../../../index.html" class="icon icon-home" aria-label="Home"></a></li>
          <li class="breadcrumb-item"><a href="../../index.html">Module code</a></li>
          <li class="breadcrumb-item"><a href="../../nl2declare.html">nl2declare</a></li>
      <li class="breadcrumb-item active">nl2declare.evaluation.evaluator</li>
      <li class="wy-breadcrumbs-aside">
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <h1>Source code for nl2declare.evaluation.evaluator</h1><div class="highlight"><pre>
<span></span><span class="kn">from</span> <span class="nn">decimal</span> <span class="kn">import</span> <span class="n">Decimal</span>
<span class="kn">from</span> <span class="nn">typing</span> <span class="kn">import</span> <span class="n">Tuple</span><span class="p">,</span> <span class="n">Dict</span>

<span class="kn">from</span> <span class="nn">nl2declare.constructs.action</span> <span class="kn">import</span> <span class="n">Action</span>
<span class="kn">from</span> <span class="nn">nl2declare.constructs.declare_constraint</span> <span class="kn">import</span> <span class="n">DeclareConstraint</span>
<span class="kn">from</span> <span class="nn">nl2declare.constructs.declare_model</span> <span class="kn">import</span> <span class="n">DeclareModel</span>


<div class="viewcode-block" id="Evaluator"><a class="viewcode-back" href="../../../nl2declare.evaluation.html#nl2declare.evaluation.evaluator.Evaluator">[docs]</a><span class="k">class</span> <span class="nc">Evaluator</span><span class="p">:</span>
    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">df</span> <span class="o">=</span> <span class="n">Decimal</span><span class="p">(</span><span class="s1">&#39;0.00&#39;</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">tpm</span> <span class="o">=</span> <span class="p">{}</span> <span class="c1">#true positives</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">fpm</span> <span class="o">=</span> <span class="p">{}</span> <span class="c1">#false positives </span>
        <span class="bp">self</span><span class="o">.</span><span class="n">fnm</span> <span class="o">=</span> <span class="p">{}</span> <span class="c1">#false negatives</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">tem</span> <span class="o">=</span> <span class="p">{}</span> <span class="c1">#type errors</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">aem</span> <span class="o">=</span> <span class="p">{}</span> <span class="c1">#activity errors</span>

<div class="viewcode-block" id="Evaluator.evaluate_case"><a class="viewcode-back" href="../../../nl2declare.evaluation.html#nl2declare.evaluation.evaluator.Evaluator.evaluate_case">[docs]</a>    <span class="k">def</span> <span class="nf">evaluate_case</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">generated</span><span class="p">:</span> <span class="n">DeclareModel</span><span class="p">,</span> <span class="n">gs</span><span class="p">:</span> <span class="n">DeclareModel</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Tuple</span><span class="p">[</span><span class="nb">float</span><span class="p">,</span> <span class="nb">float</span><span class="p">,</span> <span class="n">Dict</span><span class="p">[</span><span class="n">DeclareConstraint</span><span class="p">,</span> <span class="n">DeclareConstraint</span><span class="p">]]:</span>
        <span class="n">col</span> <span class="o">=</span> <span class="n">gs</span><span class="o">.</span><span class="n">collection</span>

        <span class="k">if</span> <span class="n">col</span> <span class="ow">not</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">tpm</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">tpm</span><span class="p">[</span><span class="n">col</span><span class="p">]</span> <span class="o">=</span> <span class="mi">0</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">fpm</span><span class="p">[</span><span class="n">col</span><span class="p">]</span> <span class="o">=</span> <span class="mi">0</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">fnm</span><span class="p">[</span><span class="n">col</span><span class="p">]</span> <span class="o">=</span> <span class="mi">0</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">tem</span><span class="p">[</span><span class="n">col</span><span class="p">]</span> <span class="o">=</span> <span class="mi">0</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">aem</span><span class="p">[</span><span class="n">col</span><span class="p">]</span> <span class="o">=</span> <span class="mi">0</span>

        <span class="n">mtp</span> <span class="o">=</span> <span class="mi">0</span>
        <span class="n">mfp</span> <span class="o">=</span> <span class="mi">0</span>
        <span class="n">mfn</span> <span class="o">=</span> <span class="mi">0</span>

        <span class="k">for</span> <span class="n">gs_con</span> <span class="ow">in</span> <span class="n">gs</span><span class="o">.</span><span class="n">constraints</span><span class="p">:</span>
            <span class="n">mfn</span> <span class="o">+=</span> <span class="n">gs_con</span><span class="o">.</span><span class="n">size</span><span class="p">()</span>

        <span class="n">matches</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">greedy_matching</span><span class="p">(</span><span class="n">generated</span><span class="p">,</span> <span class="n">gs</span><span class="p">)</span> <span class="c1">#create matches dictionary Dict[DeclareConstraint, DeclareConstraint]</span>

        <span class="k">for</span> <span class="n">gen_con</span><span class="p">,</span> <span class="n">gs_con</span> <span class="ow">in</span> <span class="n">matches</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
            <span class="n">tp</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">quantify_match</span><span class="p">(</span><span class="n">gen_con</span><span class="p">,</span> <span class="n">gs_con</span><span class="p">)</span>
            <span class="n">fp</span> <span class="o">=</span> <span class="n">gen_con</span><span class="o">.</span><span class="n">size</span><span class="p">()</span> <span class="o">-</span> <span class="n">tp</span>
            <span class="n">fn</span> <span class="o">=</span> <span class="mi">0</span> <span class="k">if</span> <span class="n">gs_con</span> <span class="ow">is</span> <span class="kc">None</span> <span class="k">else</span> <span class="n">gs_con</span><span class="o">.</span><span class="n">size</span><span class="p">()</span> <span class="o">-</span> <span class="n">tp</span>

            <span class="n">mtp</span> <span class="o">+=</span> <span class="n">tp</span>
            <span class="n">mfp</span> <span class="o">+=</span> <span class="n">fp</span>
            <span class="n">mfn</span> <span class="o">-=</span> <span class="n">tp</span>

            <span class="k">if</span> <span class="n">fp</span> <span class="o">!=</span> <span class="mi">0</span> <span class="ow">and</span> <span class="n">fn</span> <span class="o">!=</span> <span class="mi">0</span><span class="p">:</span>
                <span class="nb">print</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;GS:    </span><span class="si">{</span><span class="n">gs_con</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">)</span>
                <span class="k">if</span> <span class="n">gen_con</span><span class="o">.</span><span class="n">type</span> <span class="o">!=</span> <span class="n">gs_con</span><span class="o">.</span><span class="n">type</span><span class="p">:</span>
                    <span class="bp">self</span><span class="o">.</span><span class="n">tem</span><span class="p">[</span><span class="n">col</span><span class="p">]</span> <span class="o">+=</span> <span class="mi">1</span>
                    <span class="nb">print</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;TYPE ERROR. Found: </span><span class="si">{</span><span class="n">gen_con</span><span class="o">.</span><span class="n">type</span><span class="si">}</span><span class="s2">. GSType: </span><span class="si">{</span><span class="n">gs_con</span><span class="o">.</span><span class="n">type</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">)</span>
                <span class="k">if</span> <span class="ow">not</span> <span class="bp">self</span><span class="o">.</span><span class="n">equal_actions</span><span class="p">(</span><span class="n">gen_con</span><span class="o">.</span><span class="n">action_a</span><span class="p">,</span> <span class="n">gs_con</span><span class="o">.</span><span class="n">action_a</span><span class="p">):</span>
                    <span class="bp">self</span><span class="o">.</span><span class="n">aem</span><span class="p">[</span><span class="n">col</span><span class="p">]</span> <span class="o">+=</span> <span class="mi">1</span>
                <span class="k">if</span> <span class="ow">not</span> <span class="bp">self</span><span class="o">.</span><span class="n">equal_actions</span><span class="p">(</span><span class="n">gen_con</span><span class="o">.</span><span class="n">action_b</span><span class="p">,</span> <span class="n">gs_con</span><span class="o">.</span><span class="n">action_b</span><span class="p">):</span>
                    <span class="bp">self</span><span class="o">.</span><span class="n">aem</span><span class="p">[</span><span class="n">col</span><span class="p">]</span> <span class="o">+=</span> <span class="mi">1</span>

        <span class="k">for</span> <span class="n">gs_constraint</span> <span class="ow">in</span> <span class="n">gs</span><span class="o">.</span><span class="n">constraints</span><span class="p">:</span>
            <span class="k">if</span> <span class="n">gs_constraint</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">matches</span><span class="o">.</span><span class="n">values</span><span class="p">():</span>
                <span class="nb">print</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;MISSED: </span><span class="si">{</span><span class="n">gs_constraint</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">)</span>

        <span class="n">prec</span> <span class="o">=</span> <span class="mi">0</span> <span class="k">if</span> <span class="n">mtp</span> <span class="o">+</span> <span class="n">mfp</span> <span class="o">==</span> <span class="mi">0</span> <span class="k">else</span> <span class="n">Decimal</span><span class="p">(</span><span class="n">mtp</span><span class="p">)</span> <span class="o">/</span> <span class="n">Decimal</span><span class="p">(</span><span class="n">mtp</span> <span class="o">+</span> <span class="n">mfp</span><span class="p">)</span>
        <span class="n">rec</span> <span class="o">=</span> <span class="n">Decimal</span><span class="p">(</span><span class="n">mtp</span><span class="p">)</span> <span class="o">/</span> <span class="n">Decimal</span><span class="p">(</span><span class="n">mtp</span> <span class="o">+</span> <span class="n">mfn</span><span class="p">)</span>
        <span class="nb">print</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;Case precision: </span><span class="si">{</span><span class="n">prec</span><span class="si">:</span><span class="s2">.2f</span><span class="si">}</span><span class="s2"> recall: </span><span class="si">{</span><span class="n">rec</span><span class="si">:</span><span class="s2">.2f</span><span class="si">}</span><span class="se">\n</span><span class="s2">&quot;</span><span class="p">)</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">tpm</span><span class="p">[</span><span class="n">col</span><span class="p">]</span> <span class="o">+=</span> <span class="n">mtp</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">fpm</span><span class="p">[</span><span class="n">col</span><span class="p">]</span> <span class="o">+=</span> <span class="n">mfp</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">fnm</span><span class="p">[</span><span class="n">col</span><span class="p">]</span> <span class="o">+=</span> <span class="n">mfn</span>

        <span class="k">return</span> <span class="n">prec</span><span class="p">,</span> <span class="n">rec</span><span class="p">,</span> <span class="n">matches</span></div>

<div class="viewcode-block" id="Evaluator.print_collection_results"><a class="viewcode-back" href="../../../nl2declare.evaluation.html#nl2declare.evaluation.evaluator.Evaluator.print_collection_results">[docs]</a>    <span class="k">def</span> <span class="nf">print_collection_results</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">col</span><span class="p">:</span> <span class="nb">int</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="kc">None</span><span class="p">:</span>
        <span class="nb">print</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;</span><span class="se">\n</span><span class="s2">Collection: </span><span class="si">{</span><span class="n">col</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">)</span>
        <span class="n">ttp</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">tpm</span><span class="p">[</span><span class="n">col</span><span class="p">]</span>
        <span class="n">tfp</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">fpm</span><span class="p">[</span><span class="n">col</span><span class="p">]</span>
        <span class="n">tfn</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">fnm</span><span class="p">[</span><span class="n">col</span><span class="p">]</span>

        <span class="n">prec</span> <span class="o">=</span> <span class="n">Decimal</span><span class="p">(</span><span class="n">ttp</span><span class="p">)</span> <span class="o">/</span> <span class="n">Decimal</span><span class="p">(</span><span class="n">ttp</span> <span class="o">+</span> <span class="n">tfp</span><span class="p">)</span>
        <span class="n">rec</span> <span class="o">=</span> <span class="n">Decimal</span><span class="p">(</span><span class="n">ttp</span><span class="p">)</span> <span class="o">/</span> <span class="n">Decimal</span><span class="p">(</span><span class="n">ttp</span> <span class="o">+</span> <span class="n">tfn</span><span class="p">)</span>

        <span class="nb">print</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;Type errors: </span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">tem</span><span class="p">[</span><span class="n">col</span><span class="p">]</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">)</span>
        <span class="nb">print</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;Activity errors: </span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">aem</span><span class="p">[</span><span class="n">col</span><span class="p">]</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">)</span>
        <span class="nb">print</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;Overall precision: </span><span class="si">{</span><span class="n">prec</span><span class="si">:</span><span class="s2">.2f</span><span class="si">}</span><span class="s2"> recall: </span><span class="si">{</span><span class="n">rec</span><span class="si">:</span><span class="s2">.2f</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">)</span></div>

<div class="viewcode-block" id="Evaluator.print_overall_results"><a class="viewcode-back" href="../../../nl2declare.evaluation.html#nl2declare.evaluation.evaluator.Evaluator.print_overall_results">[docs]</a>    <span class="k">def</span> <span class="nf">print_overall_results</span><span class="p">(</span><span class="bp">self</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="kc">None</span><span class="p">:</span>
        <span class="n">ttp</span> <span class="o">=</span> <span class="mi">0</span>
        <span class="n">tfp</span> <span class="o">=</span> <span class="mi">0</span>
        <span class="n">tfn</span> <span class="o">=</span> <span class="mi">0</span>
        <span class="n">type_errors</span> <span class="o">=</span> <span class="mi">0</span>
        <span class="n">act_errors</span> <span class="o">=</span> <span class="mi">0</span>

        <span class="k">for</span> <span class="n">collection</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">tpm</span><span class="o">.</span><span class="n">keys</span><span class="p">():</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">print_collection_results</span><span class="p">(</span><span class="n">collection</span><span class="p">)</span>
            <span class="n">ttp</span> <span class="o">+=</span> <span class="bp">self</span><span class="o">.</span><span class="n">tpm</span><span class="p">[</span><span class="n">collection</span><span class="p">]</span>
            <span class="n">tfp</span> <span class="o">+=</span> <span class="bp">self</span><span class="o">.</span><span class="n">fpm</span><span class="p">[</span><span class="n">collection</span><span class="p">]</span>
            <span class="n">tfn</span> <span class="o">+=</span> <span class="bp">self</span><span class="o">.</span><span class="n">fnm</span><span class="p">[</span><span class="n">collection</span><span class="p">]</span>
            <span class="n">type_errors</span> <span class="o">+=</span> <span class="bp">self</span><span class="o">.</span><span class="n">tem</span><span class="p">[</span><span class="n">collection</span><span class="p">]</span>
            <span class="n">act_errors</span> <span class="o">+=</span> <span class="bp">self</span><span class="o">.</span><span class="n">aem</span><span class="p">[</span><span class="n">collection</span><span class="p">]</span>

        <span class="n">prec</span> <span class="o">=</span> <span class="n">Decimal</span><span class="p">(</span><span class="n">ttp</span><span class="p">)</span> <span class="o">/</span> <span class="n">Decimal</span><span class="p">(</span><span class="n">ttp</span> <span class="o">+</span> <span class="n">tfp</span><span class="p">)</span>
        <span class="n">rec</span> <span class="o">=</span> <span class="n">Decimal</span><span class="p">(</span><span class="n">ttp</span><span class="p">)</span> <span class="o">/</span> <span class="n">Decimal</span><span class="p">(</span><span class="n">ttp</span> <span class="o">+</span> <span class="n">tfn</span><span class="p">)</span>

        <span class="nb">print</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;</span><span class="se">\n</span><span class="s2">Type errors: </span><span class="si">{</span><span class="n">type_errors</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">)</span>
        <span class="nb">print</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;Activity errors: </span><span class="si">{</span><span class="n">act_errors</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">)</span>
        <span class="nb">print</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;Overall precision: </span><span class="si">{</span><span class="n">prec</span><span class="si">:</span><span class="s2">.2f</span><span class="si">}</span><span class="s2"> recall: </span><span class="si">{</span><span class="n">rec</span><span class="si">:</span><span class="s2">.2f</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">)</span></div>

<div class="viewcode-block" id="Evaluator.greedy_matching"><a class="viewcode-back" href="../../../nl2declare.evaluation.html#nl2declare.evaluation.evaluator.Evaluator.greedy_matching">[docs]</a>    <span class="k">def</span> <span class="nf">greedy_matching</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">gen_model</span><span class="p">:</span> <span class="n">DeclareModel</span><span class="p">,</span> <span class="n">gs_model</span><span class="p">:</span> <span class="n">DeclareModel</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Dict</span><span class="p">[</span><span class="n">DeclareConstraint</span><span class="p">,</span> <span class="n">DeclareConstraint</span><span class="p">]:</span>
        <span class="n">res</span> <span class="o">=</span> <span class="p">{}</span>

        <span class="k">for</span> <span class="n">score</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="mi">4</span><span class="p">,</span> <span class="o">-</span><span class="mi">1</span><span class="p">,</span> <span class="o">-</span><span class="mi">1</span><span class="p">):</span>
            <span class="k">for</span> <span class="n">gen_con</span> <span class="ow">in</span> <span class="n">gen_model</span><span class="o">.</span><span class="n">constraints</span><span class="p">:</span>
                <span class="k">for</span> <span class="n">gs_con</span> <span class="ow">in</span> <span class="n">gs_model</span><span class="o">.</span><span class="n">constraints</span><span class="p">:</span>
                    <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">quantify_match</span><span class="p">(</span><span class="n">gen_con</span><span class="p">,</span> <span class="n">gs_con</span><span class="p">)</span> <span class="o">==</span> <span class="n">score</span><span class="p">:</span>
                        <span class="k">if</span> <span class="n">gen_con</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">res</span> <span class="ow">and</span> <span class="n">gs_con</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">res</span><span class="o">.</span><span class="n">values</span><span class="p">():</span>
                            <span class="n">res</span><span class="p">[</span><span class="n">gen_con</span><span class="p">]</span> <span class="o">=</span> <span class="n">gs_con</span>

        <span class="k">for</span> <span class="n">gen_con</span> <span class="ow">in</span> <span class="n">gen_model</span><span class="o">.</span><span class="n">constraints</span><span class="p">:</span>
            <span class="k">if</span> <span class="n">gen_con</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">res</span><span class="p">:</span>
                <span class="n">res</span><span class="p">[</span><span class="n">gen_con</span><span class="p">]</span> <span class="o">=</span> <span class="kc">None</span>

        <span class="k">return</span> <span class="n">res</span></div>

<div class="viewcode-block" id="Evaluator.quantify_match"><a class="viewcode-back" href="../../../nl2declare.evaluation.html#nl2declare.evaluation.evaluator.Evaluator.quantify_match">[docs]</a>    <span class="k">def</span> <span class="nf">quantify_match</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">con1</span><span class="p">:</span> <span class="n">DeclareConstraint</span><span class="p">,</span> <span class="n">con2</span><span class="p">:</span> <span class="n">DeclareConstraint</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="nb">int</span><span class="p">:</span>
        <span class="k">if</span> <span class="n">con1</span> <span class="ow">is</span> <span class="kc">None</span> <span class="ow">or</span> <span class="n">con2</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
            <span class="k">return</span> <span class="mi">0</span>

        <span class="n">res</span> <span class="o">=</span> <span class="mi">0</span>
        <span class="k">if</span> <span class="n">con1</span><span class="o">.</span><span class="n">type</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span> <span class="ow">and</span> <span class="n">con1</span><span class="o">.</span><span class="n">type</span> <span class="o">==</span> <span class="n">con2</span><span class="o">.</span><span class="n">type</span><span class="p">:</span>
            <span class="n">res</span> <span class="o">+=</span> <span class="mi">1</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">equal_actions</span><span class="p">(</span><span class="n">con1</span><span class="o">.</span><span class="n">action_a</span><span class="p">,</span> <span class="n">con2</span><span class="o">.</span><span class="n">action_a</span><span class="p">):</span>
            <span class="n">res</span> <span class="o">+=</span> <span class="mi">1</span>

        <span class="k">if</span> <span class="n">con2</span><span class="o">.</span><span class="n">action_b</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span> <span class="ow">and</span> <span class="bp">self</span><span class="o">.</span><span class="n">equal_actions</span><span class="p">(</span><span class="n">con1</span><span class="o">.</span><span class="n">action_b</span><span class="p">,</span> <span class="n">con2</span><span class="o">.</span><span class="n">action_b</span><span class="p">):</span>
            <span class="n">res</span> <span class="o">+=</span> <span class="mi">1</span>

        <span class="k">if</span> <span class="n">con2</span><span class="o">.</span><span class="n">is_negative</span> <span class="ow">and</span> <span class="n">con1</span><span class="o">.</span><span class="n">is_negative</span><span class="p">:</span>
            <span class="n">res</span> <span class="o">+=</span> <span class="mi">1</span>
            <span class="k">if</span> <span class="ow">not</span> <span class="p">(</span><span class="n">con1</span><span class="o">.</span><span class="n">type</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span> <span class="ow">and</span> <span class="n">con1</span><span class="o">.</span><span class="n">type</span> <span class="o">==</span> <span class="n">con2</span><span class="o">.</span><span class="n">type</span><span class="p">):</span>
                <span class="n">res</span> <span class="o">+=</span> <span class="mi">1</span>

        <span class="k">return</span> <span class="n">res</span></div>

<div class="viewcode-block" id="Evaluator.equal_actions"><a class="viewcode-back" href="../../../nl2declare.evaluation.html#nl2declare.evaluation.evaluator.Evaluator.equal_actions">[docs]</a>    <span class="nd">@staticmethod</span>
    <span class="k">def</span> <span class="nf">equal_actions</span><span class="p">(</span><span class="n">action1</span><span class="p">:</span> <span class="n">Action</span><span class="p">,</span> <span class="n">action2</span><span class="p">:</span> <span class="n">Action</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="nb">bool</span><span class="p">:</span>
        <span class="k">if</span> <span class="n">action1</span> <span class="ow">is</span> <span class="kc">None</span> <span class="ow">and</span> <span class="n">action2</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
            <span class="k">return</span> <span class="kc">True</span>
        <span class="k">if</span> <span class="n">action1</span> <span class="ow">is</span> <span class="kc">None</span> <span class="ow">or</span> <span class="n">action2</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
            <span class="k">return</span> <span class="kc">False</span>

        <span class="n">gs_verb</span> <span class="o">=</span> <span class="n">action2</span><span class="o">.</span><span class="n">action_str</span><span class="p">()</span><span class="o">.</span><span class="n">split</span><span class="p">(</span><span class="s2">&quot; &quot;</span><span class="p">)[</span><span class="mi">0</span><span class="p">]</span>

        <span class="k">return</span> <span class="n">action1</span><span class="o">.</span><span class="n">action_str</span><span class="p">()</span><span class="o">.</span><span class="n">lower</span><span class="p">()</span><span class="o">.</span><span class="n">find</span><span class="p">(</span><span class="n">gs_verb</span><span class="p">)</span> <span class="o">!=</span> <span class="o">-</span><span class="mi">1</span> <span class="ow">or</span> <span class="n">action2</span><span class="o">.</span><span class="n">action_str</span><span class="p">()</span><span class="o">.</span><span class="n">find</span><span class="p">(</span><span class="n">action1</span><span class="o">.</span><span class="n">verb</span><span class="p">)</span> <span class="o">!=</span> <span class="o">-</span><span class="mi">1</span></div></div>
</pre></div>

           </div>
          </div>
          <footer>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright 2024, Pia Halkour, Marc Ludevid Wulf, Julian Kofferath.</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>